Part ShapeFromMesh

From FreeCAD Documentation

Part ShapeFromMesh‏‎

Menu location
Part → Create shape from mesh...
Workbenches
Part
Default shortcut
None
Introduced in version
-
See also
Part ConvertToSolid, Part RefineShape, Part PointsFromMesh

Introduction

The Part ShapeFromMesh command creates a shape from a mesh object. Mesh objects have limited editing capabilities in FreeCAD, converting them to shapes will allow their use with many more boolean and modification tools.

The inverse operation is Mesh FromPartShape from the Mesh Workbench.

Usage

  1. Analyzing and repairing the mesh object, if needed, should be done before launching this command. Appropriate tools for this task are available in the Mesh Workbench.
  2. Select the mesh object.
  3. Select the Part → Create shape from mesh option from the menu.
  4. The Shape from mesh dialog opens.
  5. Optionally check the Sew shape checkbox and specify a tolerance:
    • This option is usually not needed. It is meant for mesh objects that are not watertight and have small gaps between edges.
    • If the option is selected a compound of shells, instead of a compound of faces, is created.
    • The sewing operation may be computationally demanding.
  6. Press the OK button.
  7. A shape is created as a separate new object.
  8. Optionally turn this object into a solid with Part MakeSolid.
  9. Optionally use Part RefineShape on the final object.

Links

Scripting

Creating a Shape from a Mesh can be done by using the makeShapeFromMesh method from a Part TopoShape; you need to specify the source mesh and tolerance, and assign the result to a new Part Feature object.

Notice that the mesh must be recalculated before it is converted to a Shape, otherwise there won't be topology information, and the conversion won't be successful.

import FreeCAD as App
import Part

doc = App.newDocument()
mesh = doc.addObject("Mesh::Cube", "Mesh")
mesh.recompute()

solid = doc.addObject("Part::Feature", "Shape")
shape = Part.Shape()
shape.makeShapeFromMesh(mesh.Mesh.Topology, 0.1)

solid.Shape = shape
solid.Placement.Base = App.Vector(15, 0, 0)
solid.purgeTouched()
doc.recompute()